import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Launches a bullet fired by the Drunken Star, that harms many enemies
 * 
 * @Andrew I Letailleur
 * @15/03/2015, Version 2-04
 */
public class Bullet extends Projectile
{
   //class level attributes
   public int direction, speed;
   private int fuse = 3;//innitial fuse value
   /**
     * Set ups the Bullet's innitial appearance
     */
   public Bullet() // Do NOT do Void
   {//local variables
       //Original Image Size is set at 63 x 42
       GreenfootImage image = getImage();
       image.scale(image.getWidth()-46, image.getHeight()-31);
       setImage(image);
       
       //direction = dir;
       //setRotation(direction);
       speed = 15;
   }//end of method Bullet
    
   /**
    * Act - do whatever the BulletN wants to do. This method is called whenever
    * the 'Act' or 'Run' button gets pressed in the environment.
    */
   public void act() 
   {//local variables
       move(speed);
       //setLocation(getX(), getY() - speed); old code
       checkCollision();
   }//end of method act

   /**
    * Checks to see if Bullet is colliding with another Actor or at Edge of the World
    */
   public void checkCollision()
   {//local variables
       //returns actors that are touching the Bullet
       Actor stalk = getOneIntersectingObject(Stalker.class);
       Actor bomb = getOneIntersectingObject(Bomb.class);
       Actor wolf = getOneIntersectingObject(Wolf.class);
       Actor pigeon = getOneIntersectingObject(Pigeon.class);
       Actor bat = getOneIntersectingObject(Bat.class);
       if(atWorldEdge(this))//if Bullet is at the Edge of the World from the Projectile Super Class
           removeBullet();//removes Bullet from Gameplay
       else if (fuse < 3)//If fuse is lower than standard
            checkFuse();
       else if (fuse > 2){//if fuse is at the standard value
            if ( (stalk != null) || (bomb != null) || (wolf != null) || (pigeon != null) || (bat != null) )
                fuse = 2;//lowers the fuse by a notch
       }//end bullet check conditions
   }//end of method checkCollision
   
   /**
    * Checks the current fuse level. If it's at 0, it removes the bullet. If above 0, will lower the fuse
    */
   public void checkFuse()
   {//local variables
       if (fuse <= 0)//above 0
           removeBullet();
       else //lowers fuse by 1
           fuse--;
       //endif fuse check
   }//end of method checkFuse
   
   /**
    * Removes the Bullet object from the world
    */
   public void removeBullet()
   {//local variables
       Gameplay thisWorld = (Gameplay) getWorld();//calls upon the Gameplay world for alterations
       thisWorld.removeObject(this);//removes itself from world
   }//end of method removeBullet
}//end of actor Bullet