import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Flash appears if a Bullet hits an Enemy class, and designed to 'disappear' when it's timer reaches 0
 * Designed as a 'special effect' to make transition more believable
 * 
 * @Andrew I Letailleur
 * @13/03/2015, Version 2-03
 */
public class Flash extends Blast
{
    //class level attributes
    protected int timer = 12;
    /**
     * Sets up the Flashs innitial appearance, along with playing a sound on appearing in game
     */
    public Flash()
    {//local variables
        //Original Image Size is set at 284 x 283
        GreenfootImage image = getImage();
        image.scale(image.getWidth() -230, image.getHeight() -230);
        //consider -120 once gameplay balancing starts, if the explosions are 'too' easy
        setImage(image);
        
        play("hit.wav", 0);
    }//end of method Flash
    /**
     * Act - do whatever the Flash wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    { //local variables
        
        GreenfootImage image = getImage();//calls upon the current image
        image.scale(image.getWidth() -3, image.getHeight() -3);//shrinks the image slightly
        setImage(image);//sets the image as the new image
        
        turn(3);
        countdown();//calls upon the countdown
    }//end of method act
    /**
     * Counts down the timer until it reaches 0, afterwards it will remove the explosion and bomb count
     */
    public void countdown()
    {//local variables
        if (timer == 0) {//the flash will vanish once it's timer is at 0
            //calls upon the Gameplay world to remove the flash from game
            Gameplay thisWorld = (Gameplay) getWorld();
            thisWorld.removeObject(this);
        } else {//will count down on the timer, until it reaches 0
            timer--;
        }//endif timer
    }//end of method countdown
}//end of class Explosion