import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The Gameplay Super World sets up and generates all of the worlds. All of them, including the title screen.
 *
 * @Andrew I Letailleur
 * @015/03/2015, Version 2-04
 */
public class Gameplay extends World
{
    //class level attributes
     
    protected Star player;
    public int playerX=300;
    public int playerY=300;
    /** - Old Commentary of guesstimated values still existing to this day, I've redacted implemented variables
     * Guessed variables
     * -
     * private ScoreBoard theScore
     */
    private int spawnEdge;
    public byte gPlay = 1;

    public int maxxCap, stalkerCap, bombCap, wolfCap, pigeonCap, batCap, lavaCap= 0;
    private int spawnStalker, spawnBomb, spawnWolf, spawnPigeon, spawnBat, spawnLava;
    //Lava is there, in case of my idea on three image render works via 3 actor miracles bitches.
    public double counter = 0;
    public int killCount, popCap;
    private int BGM = 0;
    /**
     * will play a sound file and create a delay to allow the file to play
     * is set at protected so that only other worlds can access this class freely, without repeating code
     */
    protected void play(String sound, int delayTime)
    {//will play a sound file and create a delay
        //local variables
        Greenfoot.playSound(sound);//to allow the file to play
        Greenfoot.delay(delayTime);//creates a delay
    }//end of method Play
    /**
     * Constructor for objects of class Gameplay.
     */
    public Gameplay()
    {// Create a new world with 600x600 cells with a cell size of 1x1 pixels.
        super(600, 600, 1); 
        setPaintOrder(Star.class); //this may help with run over glitches?
        player = new Star();
        populateWorld();
        //menuScreen();
    }//end of constructor
    /**
     * Constructor for objects of class Gameplay, to import the Star player from previous stages
     */
    public Gameplay(Star player)
    {// Create yet another new world with 600 x 600 cells with a cell size of 1x1 pixels, just for the Star.
        super(600, 600, 1); 
        setPaintOrder(Star.class); //this may help with run over glitches?
        this.player = player;
        populateWorld();
    }//end of constructor (Star player)
    /* End of section constructor
     */
    /**
     * updatePlayerX & updatePlayerY updates the players current location so that Stalkers can home in on them
     */
    public int updatePlayerX()
    {
        //local variables
        playerX = player.trackStarX();
        return playerX;
    }//end of updatePlayer, part X
    public int updatePlayerY()
    {
        //local variables
        playerY = player.trackStarY();
        return playerY;
    }//end of updatePlayer, part Y
    /**
     * Returns the current killCount for use of the Star actor.
     */
    public int killCounter()
    {
        //local variables
        return killCount;
    }
    /* End of section player track
     */
    /**
     * Section Scoring Board, used to;
     * -Return the score,
     * -Update score with enemies killed via bullets
     * -and clear the total score upon replaying the game.
     */
    public double scoreCounter()
    {
        //local variables
        return counter;
    }
    /**
     * Updates current counter with the value the enemies return upon being killed by a bullet
     */
    public void Wolf()
    {
        //local variables
        counter = counter + 8;
        //scoreCounter();  //update();
    }//end of method Wolf
    public void Stalker()
    {
        //local variables
        counter = counter + 6;
        scoreCounter();  //update();
    }//end of method Stalker
    public void Pigeon()
    {
        //local variables
        counter = counter + 4;
        //scoreCounter();  //update();
    }//end of method Pigeon
    public void Bat()
    {
        //local variables
        counter = counter + 2;
        //scoreCounter();  //update();
    }//end of method Bat
    /**
     * Inflicts a score penalty if the player loses a life
     */
    public void Penalty()
    {
        counter = counter * 0.9;
        //scoreCounter();  //update();
    }//end of method Penalty
    /**
     * Clears the score upon starting a new game
     */
    public void Clear()
    {
        counter = 0;
        BGM = 0;
        //scoreCounter();  //update();
    }//end of method Clear
    /**
     * Possibly refreshes the score, in case it's required? Possibly not needed
     */
    private void update()
    {
        //scoreCounter();
    }//end of method update
    /* End of section Scoreing Board
     */
    /**
     * Checks for ending conditions, and generates enemies if player is on
     * Also checks for keyboard imput upon an ending condition being met
     */
    public void act()
    {
        //local variables
        if(gPlay == 0) {//checks to see if game is no longer being played
            if ( Greenfoot.isKeyDown("r") ){//restarts the game, and sets the gameplay to '1' for 'ON'
                Greenfoot.setWorld(new bCity()); //resets the game back to 'level 1'
                gPlay = 1;//sets the gameplay to 'ON'
                
                Clear();//clears the score tally, for a fresh replay
                populateWorld();//sets up the actors on stage
            }//endif 'r' is pressed
            else if ( Greenfoot.isKeyDown("m") ){//checks to see if player wants to return to the main menu
                Greenfoot.setWorld(new Title());//switches the 
                Clear(); //clears the score tally, for a fresh replay
            }//endif 'm' is pressed
        }//endif 'gameplay' is OFF
        if((player.getLives()<=0)){//sets up the game ove ending screen if player star runs out of lives
            removeObjects(getObjects(null)); //removes all onboard actors, clearing the screen
            setBackground("GameOver.png"); //changes the screen to a 'game over' screen
            gPlay = 0;//sets the gameplay to 'OFF'
        }//endif lives < 1
        else if((player.getLevel()>2)){//checks to see if player level is past the 'Red Cave' level
            removeObjects(getObjects(null)); //removes all onboard actors, clearing the screen
            gPlay = 0;//sets the gameplay to 'OFF'
            if((player.getLives() >= 3)){//checks to see if player meets the GOLDEN ENDING criteria
                setBackground("TheWinner.png");//BEST ending
                //if(BGM <= 0){
                //    play("StarGold.wav", 1600);
                //    BGM = 1;//600;
                    //} else {
                    //BGM--;
                //}
            } else {//returns the default ending previous condition isn't met
                setBackground("YouWinner.png");//standard ending
                //if(BGM <= 0){
                //    play("StarMenu.wav", 300);
                //    BGM = 6;//00;
                    //} else {
                    //BGM--;
                //} //endif ending conditions
            }
        }//endif level > 2
        if (player.getLevel() >= 0) //sets the max population cap, limiting the amount of enemies on screen
            popCap = 5;
        else if (player.getLevel() >= 1)
            popCap = 7;
        else if (player.getLevel() == 2)
            popCap = 9; //end if popCap limit
        if (player.getLevel() >= 0){//will always spawn for the freshly spawned Star
            if( (maxxCap < popCap) && (gPlay == 1) ) {//checks for spawning conditions of 'level 1' enemies
                //spawns Stalker and Bomb actors
                spawnStalker = Greenfoot.getRandomNumber(100);
                if( (spawnStalker < 2 ) && (stalkerCap < 3) ) {//spawn rate for Stalkers
                    stalkerCap++;
                    maxxCap++;
                    spawnEdge = Greenfoot.getRandomNumber(4); // Spawns stalker at a random 'edge'
                    if (spawnEdge == 0) {
                        addObject(new Stalker(), Greenfoot.getRandomNumber(600), 0);
                    } else if(spawnEdge == 1) {
                        addObject(new Stalker(), 0, Greenfoot.getRandomNumber(600));
                    } else if(spawnEdge == 2) {
                        addObject(new Stalker(), Greenfoot.getRandomNumber(600), 600);
                    } else if(spawnEdge == 3) {
                        addObject(new Stalker(), 600, Greenfoot.getRandomNumber(600));
                    }//endif spawnEdge
                }//endif Stalker
                spawnBomb = Greenfoot.getRandomNumber(100);
                if( (spawnBomb < 3) && (bombCap < 4) ) {//spawn rate for Bombs
                    bombCap++;
                    maxxCap++;
                    //addObject spawns bomb at random location
                    addObject(new Bomb(), Greenfoot.getRandomNumber(500) + 50, Greenfoot.getRandomNumber(500) +50);
                }//endif Bomb
            }//endif spawn conditions
        }//endif level '1' enemy spawns
        if(player.getLevel() >= 1){//will start spawning once player reaches level 2 in game
            if (maxxCap < popCap){ //checks for spawning conditions of 'level 2' enemies
                //spawns Pigeon and Wolf actors
                spawnPigeon = Greenfoot.getRandomNumber(100);
                if( (spawnPigeon < 2) && (pigeonCap < 3) ){ //spawn rate for Pigeons
                    pigeonCap++;
                    maxxCap++;
                    spawnEdge = Greenfoot.getRandomNumber(4); //spawns pigeon at random 'edge'
                    if (spawnEdge == 0) {
                        Pigeon pigeon = new Pigeon();
                        addObject(pigeon, Greenfoot.getRandomNumber(600), 0); //upwards edge
                        pigeon.turn(Greenfoot.getRandomNumber(90) + 45); //sets pigeon direction randomly
                        //setRandomDirection?
                    } else if (spawnEdge == 1) {
                        Pigeon pigeon = new Pigeon();
                        addObject(pigeon, 600, Greenfoot.getRandomNumber(600)); //leftwards edge
                        pigeon.turn(Greenfoot.getRandomNumber(90) + 135); //sets pigeon direction randomly
                        //setRandomDirection?
                    } else if(spawnEdge == 2) {
                        Pigeon pigeon = new Pigeon();
                        addObject(pigeon, Greenfoot.getRandomNumber(600), 600); //downwards edge
                        pigeon.turn(Greenfoot.getRandomNumber(90) + 225); //sets pigeon direction randomly
                        //setRandomDirection?
                    } else if (spawnEdge == 3) {
                        Pigeon pigeon = new Pigeon();
                        addObject(pigeon, 0, Greenfoot.getRandomNumber(600));//rightwards edge
                        pigeon.turn(Greenfoot.getRandomNumber(90) + 315); //sets pigeon direction randomly
                        //setRandomDirection?
                    }//endif spawnEdge
                }//endif Pigeon
                spawnWolf = Greenfoot.getRandomNumber(100);
                if( (spawnWolf < 2) && (wolfCap < 3) ) {//spawn rate for Wolves
                    wolfCap++;
                    maxxCap++;
                    spawnEdge = Greenfoot.getRandomNumber(4); //spawns wolf at random 'edge'
                    if (spawnEdge == 0) {
                        Wolf wolf = new Wolf();
                        addObject(new Wolf(), Greenfoot.getRandomNumber(600), 0); //upwards edge
                        wolf.turn(Greenfoot.getRandomNumber(90) + 45); //sets wolf direction randomly
                    } if(spawnEdge == 1) {
                        Wolf wolf = new Wolf();
                        addObject(new Wolf(), 600, Greenfoot.getRandomNumber(600)); //leftwards edge
                        wolf.turn(Greenfoot.getRandomNumber(90) + 135); //sets wolf direction randomly
                    } if(spawnEdge == 2) {
                        Wolf wolf = new Wolf();
                        addObject(new Wolf(), Greenfoot.getRandomNumber(600), 600); //downwards edge
                        wolf.turn(Greenfoot.getRandomNumber(90) + 225); //sets wolf direction randomly
                    } if(spawnEdge == 3) {
                        Wolf wolf = new Wolf();
                        addObject(new Wolf(), 0, Greenfoot.getRandomNumber(600)); //rightwards edge
                        wolf.turn(Greenfoot.getRandomNumber(90) + 315); //sets wolf direction randomly
                    }//endif spawnEdge
                }//endif Wolf
            }//endif spawn conditions
        }//endif level '2' enemy spawns
        if(player.getLevel() == 2){//will only spawn at the final 'level', which is 'Red Cave'
            if (maxxCap < popCap){//checks for spawning conditions for 'level 3' enemies
                spawnBat = Greenfoot.getRandomNumber(100);
                if ( (spawnBat < 3) && (batCap < 3) ) {//spawn rate for Bats
                    batCap++;
                    maxxCap++;
                    //addObject spawns Bat at random location
                    addObject(new Bat(), Greenfoot.getRandomNumber(500) + 50, Greenfoot.getRandomNumber(500) +50);
                }//endif Bat
                /*Future code for last minute lava enemy?
                 */
                //spawnLava = Greenfoot.getRandomNumber(100); //bubble test
            }//endif spawn conditions
        }//endif level '3' enemy spawns
    }//end of method Act
    /*End of section Act, Gameplay/ending imput
     */
    /**
     * Generates the objects for Gameplay
     */
    public void populateWorld()
    {
        //local variables
        addObject(player, playerX, playerY);//spawns the player in the game
        setCheck();
        setValues();
        
        //theScore = new ScoreBoard(player, 0, 0, 0);
    }//end of method populateWorld
    
    //useless code section?
    /**
     * set up values to match the kill counter that is being played
     */
    private void setCheck()
    {
      //local variables
    
      //int kill;
      //kill = player.getKill();
    
      /*
       * if(kill=>100)
      * Level + 1
      * Kill = 0
      */
      //endif
    }
    
    private void setValues()
    {
        //local variables
        //level thingy
    }
    
    /**
     * Return the current Score, for ending condition
     */
    //public ScoreBoard getScore()
    //{
    //    return theScore;
    //}
}//end of super class Gameplay