import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * An enemy actor that poses no threat by itself, but it's 'pellets' are harmful for the Star's health
 * 
 * @Andrew I Letailleur
 * @13/03/2015, Version 2-03
 */
public class Pigeon extends Actor
{
    //class level attributes
    public int direction, speed;
    private int dying;
    public int shit, reload = 0;
    private int sTime = 50;
    /**
     * Helps set up the Pigeons innitial appearance
     */
    public Pigeon() // Do NOT do Void on spawners
    {//local variables
        //Original Image Size is set at 321 x 167
        GreenfootImage image = getImage();
        image.scale(image.getWidth()-221, image.getHeight()-117);
        setImage(image);
        
        direction = getRotation();
        //setRotation(direction);
        speed = 1;
        dying = 2;
    }//end of method pigeon
    
    /**
     * Returns true if pigeon reaches the edge of the world
     */
    private boolean atWorldEdge(Actor actor)
    {//local variables
        if((actor.getX()>=getWorld().getWidth()-(actor.getImage().getWidth()/2))||
           (actor.getX()<=(actor.getImage().getWidth()/2))||
           (actor.getY()>=getWorld().getHeight()-(actor.getImage().getHeight()/2))||
           (actor.getY()<=(actor.getImage().getHeight()/2)))
            return true;
        else
            return false;
    }//end of method atWorldEdge

    /**
     * Act - do whatever the Pigeon wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {//local variables
        if(reload > 0)
            reload--;
        if (dying < 2)
            dying--;
        //endif reload and dying  
        shit = Greenfoot.getRandomNumber(100);
        movement();
    }//end of method act
    
    /**
    * will play a sound file and create a delay
    * to allow the file to play
    */
    private void play(String sound, int delayTime)
    {//will play a sound file and create a delay
        //to allow the file to play
        Greenfoot.playSound(sound);
        Greenfoot.delay(delayTime);
    }//end of method Play
    
    /**
     * Ensures that the pigeon is always moving forward
     */
    public void movement()
    {//local variables
        move(speed);
        if(reload == 0){
           if(shit >= 95) {
              Pellet pellet = new Pellet();
              Pigeon pigeon = (this);
              getWorld().addObject (pellet, getX(), getY());
              pellet.turn(pigeon.getRotation() + 180);
              reload = 30 + Greenfoot.getRandomNumber(40) + Greenfoot.getRandomNumber(40);
           }//endif pellet spawn rate
        }//endif reload refills
        checkCollision();
    }//end of method movement
    
    /**
     * Checks to see if pigeon collides with a hazard
     */
    public void checkCollision()
    {//local variables
        Actor shot = getOneIntersectingObject(Bullet.class);
        Actor bang = getOneIntersectingObject(Explosion.class);
        Actor star = getOneIntersectingObject(StarBang.class);
        if (shot != null)//checks to see if pigeon is hit by a bullet
            bulletPigeon();
        else if ( (bang !=null) || (star !=null) )//checks to see if pigeon is caught in an explosion
            dying--;
        else if ( (dying <= 0) || (atWorldEdge(this)) && (sTime == 0) )//checks to see desoawn conditions
            killPigeon();
        //endif kill conditions
        checkEdge();
    }//end of method checkCollision
    
    /**
     * Removes Pigeon from play if the actor touches a bullet object
     */
    public void bulletPigeon()
    {//local variables
        play("seagullDies.wav", 0);
        Gameplay thisWorld = (Gameplay) getWorld();//calls upon the Gameplay world for alterations
        Flash flash = new Flash();//sets up flash for bullet hitting an enemy
        thisWorld.addObject(flash, getX(), getY());//places the flash where the actor is currently at
       
        //reduces the current pigeon and max population, to reflect the disappearing explosion
        thisWorld.pigeonCap--;
        thisWorld.maxxCap--;
        
        thisWorld.killCount++;//adds a kill to the kill counter
        thisWorld.Pigeon();//add to score method
        thisWorld.removeObject(this);//removes itself from world
    }//end of method bulletPigeon
    /**
     * Removes Pigeon from play if another hazard triggers it's death condition
     */
    public void killPigeon()
    {//local variables
        Gameplay thisWorld = (Gameplay) getWorld();
        thisWorld.removeObject(this);//removes itself from world
        
        //reduces the current pigeon and max population, to reflect the disappearing explosion
        thisWorld.pigeonCap--;
        thisWorld.maxxCap--;
    }//end of method killPigeon
    /**
     * Ensures that the Pigeon will not automatically die if spawned at the edge of the world
     */
    public void checkEdge()
    {//local variables
        if(sTime > 0)
            sTime--;
        //endif spawn time
    }//end of method checkEdge
}//end of actor Pigeon
