import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Acts as a universal code for reference on Projectiles
 * 
 * @Andrew I Letailleur
 * @13/03/2015, Version 2-03
 */
abstract class Projectile extends Actor
{
    /**
     * Act - do whatever the Projectile wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        //Don't bother with Act for now
    }//end of method act
    
    /**
     * Checks if the object has reached the edge of the screen and if it has, returns true
     */
    protected boolean atWorldEdge(Actor actor)
    {
        if((actor.getX()>=getWorld().getWidth()-(actor.getImage().getWidth()/2))||
           (actor.getX()<=(actor.getImage().getWidth()/2))||
           (actor.getY()>=getWorld().getHeight()-(actor.getImage().getHeight()/2))||
           (actor.getY()<=(actor.getImage().getHeight()/2)))
            return true;
        else
            return false;
    }//end of method atWorldEdge
}//end of super class Projectile