import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * StarBang appears if a Star is touched to kill of any hazard that harmed the star
 * Coded to kill quite a few hazards, and expand briefly before disappearing
 * 
 * @Andrew I Letailleur
 * @013/03/2015, Version 2-03
 */
public class StarBang extends Blast
{
    //class level attributes
    protected int timer = 12;
    /**
     * Sets up the Explosions innitial appearance
     */
    public StarBang()
    {//local variables
        //Original Image Size is set at 284 x 283
        GreenfootImage image = getImage();
        image.scale(image.getWidth() -120, image.getHeight() -120);
        //consider -120 once gameplay balancing starts, if the explosions are 'too' easy
        setImage(image);
    }
    
    /**
     * Act - do whatever the Explosion wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {//local variables
        GreenfootImage image = getImage();
        image.scale(image.getWidth() +4, image.getHeight() +4);
        //consider -120 once gameplay balancing starts, if the explosions are 'too' easy
        setImage(image);
        
        turn(1);
        //setRotation(+15);
        countdown();
    }
    
    /**
     * Counts down the timer until it reaches 0, afterwards it will remove the explosion and bomb count
     */
    protected void countdown()
    {//local variables
        if (timer == 0)
        {
            Gameplay thisWorld = (Gameplay) getWorld();//calls upon the Gameplay world for alterations
            thisWorld.removeObject(this);//removes itself from world
        } else {//will count down the timer
            timer--;
        }//endif timer
    }//end of method countdown
}//end of actor StarBang
