import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * An enemy actor that wonders around, acting as a threat for both the Star and Stalker
 * 
 * @Andrew I Letailleur
 * @15/03/2015, Version 2-04
 */
public class Wolf extends Actor
{
    //class level attributes
    private int lunge, lungeCheck = 0;
    private int dying;
    private int speed = 7;
    private int haste = 66;
    /**
     * Set ups the Wolf's innitial appearance
     */
    public Wolf()
    {//local variables
        //Original Image Size is set at 96 x 131
        GreenfootImage image = getImage();
        image.scale(image.getWidth() / 4, image.getHeight() / 4);
        setImage(image);
        
        dying = 2;
    }
    
    /**
     * Act - do whatever the Wolf wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        movement();
        hungerTest();
        if (dying < 2)
            dying--;
    }   
    
    /**
     * will play a sound file and create a delay to allow the file to play
     */
    private void play(String sound, int delayTime)
    {//will play a sound file and create a delay
        //to allow the file to play
        Greenfoot.playSound(sound);
        Greenfoot.delay(delayTime);
    }//end of method Play
    
    /**
     * Rolls a random number for checking the frequency of lunges
     */
    public void lungeCheck()
    {
        Greenfoot.getRandomNumber(40);
    }//end of method lungeCheck
    
    /**wip still?
     * Causes the wolf to move, along with determining it's random bursts of speed
     */
    public void movement()
    {//local variables
        if (lunge == 0) {//will check the lunge condition when it's at 0
            lungeCheck();//checks for a lunge to see if it's viable, if lunge is at 0
            if(lunge >= 1) {
                move(speed);//moves at the speed of speed
                lunge--;//counts down on lunge until it reaches 0
            } else if (lungeCheck >= 28) {//if lungeCheck chance has passed
                move(speed);
                lunge = 55;
            } else {//will move wolf at a standard speed of stalkers
                move(2);
            }//endif movement check
        } else {//will return an automatic fail condition, to prevent permament lunging
            lungeCheck = 0;//automatically sets lungeCheck at 0, if wolf is still lunging
        }//endif lunge check
        if(Greenfoot.getRandomNumber(100) <= 11) {//determines where the wolf will turn, left or right?
            turn(Greenfoot.getRandomNumber (90) - 45);
        }//endif turn check
        checkCollision();
    }//end of method movement

    /**
     * Will turn the wolf to a different direction upon arriving at Edge of the World
     */
    public void checkCollision()
    {
        if (getX() <= 5 || getX() >= getWorld().getWidth() - 5) {
            turn(180);
            move(5);
        }//endif X edge of World
        if (getY() <= 5 || getY() >= getWorld().getWidth() - 5) {
            turn(180);
            move(5);
        }//endif Y edge of World
        //returns actors that are touching the Wolf
        Actor shot = getOneIntersectingObject(Bullet.class);
        Actor bang = getOneIntersectingObject(Explosion.class);
        Actor star = getOneIntersectingObject(StarBang.class);
        if (shot != null)//if Wolf is hit by a bullet
            bulletWolf();
        else if ( (bang !=null) || (star !=null) )//if Wolf is hit by an explosion
            dying--;
        //endif kill conditions
        if(dying <= 0){//will kill Wolf if it's dying
            killWolf();
        }//endif dying condition
    }//end of method checkCollision
    
    /**
     * Kills the wolf if a bullet object hits the wolf, adding score on top of reducing the population total
     */
    public void bulletWolf()
    {
        play("wolfDies.wav", 0);//plays the Wolfs death cry
        Gameplay thisWorld = (Gameplay) getWorld();//calls upon the Gameplay world for alterations
        Flash flash = new Flash();//adds a flash for any bullet that hits the Stalker
        thisWorld.addObject(flash, getX(), getY());//places the flash where the actor is currently at
        
        //reduces the current wolf and max population, to reflect the reduced amount of enemiess around
        thisWorld.wolfCap--;
        thisWorld.maxxCap--;
        thisWorld.removeObject(this);//removes itself from world
        
        thisWorld.killCount++;//adds a kill to the kill counter
        thisWorld.Wolf();//add to score method
    }//end of method bulletWolf
    
    /**
     * Kills the wolf if an explosion hits the wolf, reducing the total population after the wolf dies
     */
    public void killWolf()
    {
        play("wolfDies.wav", 0);//plays the Wolfs death cry
        Gameplay thisWorld = (Gameplay) getWorld();//calls upon the Gameplay world for alterations
        //reduces the current wolf and max population, to reflect the reduced amount of enemiess around
        thisWorld.wolfCap--;
        thisWorld.maxxCap--;
        thisWorld.removeObject(this);//removes itself from world
    }//end of method killWolf
    
    /**
     * Dummy method aimed at having the wolf play a 'chomp' upon eating a Stalker
     */
    public void hungerTest()
    {
        //Insert devouring test
        //stalker = getOneObjectAtOffset(0, 0, Stalker.class)
    }//end of method hungerTest, possible useless code?
}//end of actor Wolf
