import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The Blast super-class is a class with the sole function of grouping all the 'blast' effects into one group,
 * In addition, it also has the neat side effect of also hosting the 'play' code for later callback
 * 
 * @Andrew I Letailleur
 * @013/03/2015, Version 2-03
 */
abstract class Blast extends Actor
{
    //class level attributes
    /**
     * Act - do whatever the Blast wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {//local variables
        // Add your action code here.
    }//end of method act
    
    /**
     * will play a sound file and create a delay
     * to allow the file to play
     */
    protected void play(String sound, int delayTime)
    {//will play a sound file and create a delay
       //to allow the file to play
       Greenfoot.playSound(sound);
       Greenfoot.delay(delayTime);
    }//end of method Play
}//end of super class Blast
